#include <windows.h>
#define TVTEST_PLUGIN_CLASS_IMPLEMENT	// vOCNXƂĎ
#include "TVTestPlugin.h"
#include "TTScroll.h"

void CTTScroll::TTScroll(HWND hWnd)
{
  //Debug Message
  //MessageBox(hWnd, L"TTScroll() was called.", L"TTScroll", MB_OK);

  int n, i;
  i = GetItemIndex(&n);

  //݂̃`[jOԂ̔ԑg\`lSv̕擾
  GuideWidth = ItemWidth * n;

  //ԑg\̃XN[\̈̕擾
  RECT r;//ԑg\̃NCAg̈
  GetClientRect(hWnd, &r);
  sClientWidth = max(r.right - r.left - (tmHeight+ITEM_MARGIN*2)*2, 0);

  int x = Get_x(i);

  if(x <= 0)
    return;

  //16bit𒴂ꍇ̃XN[o[Έʒuݒ
  //TVTestWM_HSCROLLbZ[Wł͏oȂ悤Ȃ̂
  //ΈʒuݒŃXN[
  int tsw = 0;
  if(sClientWidth <= x)
    {
      SendMessage(hWnd, WM_HSCROLL, MAKELONG(SB_THUMBTRACK, 0), 0);
      SendMessage(hWnd, WM_HSCROLL, MAKELONG(SB_THUMBPOSITION, 0), 0);
      SendMessage(hWnd, WM_HSCROLL, SB_PAGERIGHT, 0);

      //Debug Message
      //WCHAR str[32];
      //wsprintf(str, L"x:%d s:%d", GetScrollPos(hWnd, SB_HORZ), sClientWidth);
      //MessageBox(hWnd, (LPWSTR)str, L"TTScroll", MB_OK);

      int pos = GetScrollPos(hWnd, SB_HORZ);

      if(pos > sClientWidth)
	tsw = pos - sClientWidth;

      if((sClientWidth + tsw) >= x)
	return;
    }

  int n_page = sClientWidth > 0 ? (x / (sClientWidth + tsw)) : 0;
  WORD x0 = n_page > 0 ? (sClientWidth + tsw) : 0;
  x0 += sClientWidth > 0 ? (x % (sClientWidth + tsw)) : 0;
  PostMessage(hWnd, WM_HSCROLL, MAKELONG(SB_THUMBTRACK, x0), 0);
  PostMessage(hWnd, WM_HSCROLL, MAKELONG(SB_THUMBPOSITION, x0), 0);

  for(int c = 1; c < n_page; c++)
    PostMessage(hWnd, WM_HSCROLL, SB_PAGERIGHT, 0);
}

int CTTScroll::GetItemIndex(int *pNumItems)
{
  if(pNumItems != NULL)
    *pNumItems = 0;

  TVTest::ChannelInfo chInfo;
  int index = -1;

  if(!m_pApp->GetCurrentChannelInfo(&chInfo))
    return index;

  int idx0, n0;
  idx0 = GetItemIndexBySpace(&chInfo, chInfo.Space, &n0);

  //(ScrollMax+1) == ItemWidth*n
  //Phbǧ덷ȂꉞÔItemWidth/2̗]T
  bool all = (ItemWidth * n0) < (ScrollMax + 1 - (ItemWidth/2));

  if(all)
    {
      int NumSpaces;
      m_pApp->GetTuningSpace(&NumSpaces);
      int n_items = 0;
      for(int i = 0; i < NumSpaces; i++)
	{
	  int idx, n;
	  //skip current space
	  if(i == chInfo.Space)
	    {
	      idx = idx0;
	      n = n0;
	    }
	  else
	    idx = GetItemIndexBySpace(&chInfo, i, &n);

	  if(index < 0 && idx >= 0)
	    index = n_items + idx;
	  n_items += n;
	}
      if(pNumItems != NULL)
	*pNumItems = n_items;
    }
  else
    {
      index = idx0;
      if(pNumItems != NULL)
	*pNumItems = n0;
    }
  
  return index;
}

int CTTScroll::GetItemIndexBySpace(TVTest::ChannelInfo *pInfo,
				  int Space,
				  int *pNumItems)
{
  if(pNumItems != NULL)
    *pNumItems = 0;

  TVTest::ChannelInfo chInfo;
  int c, c_disabled, index = -1;

  //Space̓`[jOԂ̎ނł͂Ȃ
  //BonDriver̃CfbNXł
  for(c = 0, c_disabled = 0; m_pApp->GetChannelInfo(Space, c, &chInfo); c++)
    {
      if((chInfo.Flags & TVTest::CHANNEL_FLAG_DISABLED) ||
	 IsExcludeService(chInfo.NetworkID, chInfo.TransportStreamID, chInfo.ServiceID))
	{
	  c_disabled++;
	}
      else if(chInfo.TransportStreamID == pInfo->TransportStreamID &&
	      chInfo.ServiceID == pInfo->ServiceID)
	{
	  index = c - c_disabled;
	  if(pNumItems == NULL)
	    break;
	}
    }

  if(pNumItems != NULL)
    *pNumItems = c - c_disabled;

  return index;
}

int CTTScroll::Get_x(int i)
{
  if(i < 0)
    return 0;

  int x;
  x = ItemWidth*i-(sClientWidth-ItemWidth)/2;
  if (x < 0)
    x = 0;
  else if (x > max(GuideWidth-sClientWidth, 0))
    x = max(GuideWidth-sClientWidth, 0);

  return x;
}

bool CTTScroll::IsExcludeService(WORD NetworkID, WORD TransportStreamID, WORD ServiceID)
{
  for (int i = 0; i < ExcludeServiceCount; i++) {
    if ((NetworkID==0 || ExcludeServiceList[i]->NetworkID==NetworkID)
	&& (TransportStreamID==0 || ExcludeServiceList[i]->TransportStreamID==TransportStreamID)
	&& ExcludeServiceList[i]->ServiceID==ServiceID)
      return true;
  }
  return false;
}

// CxgR[obN֐
// CxgNƌĂ΂
LRESULT CALLBACK CTTScroll::EventCallback(UINT Event, LPARAM lParam1, LPARAM lParam2, void *pClientData)
{
  CTTScroll *pThis = static_cast<CTTScroll*>(pClientData);

  switch (Event) {
  case TVTest::EVENT_PLUGINENABLE:
    // vOC̗LԂω
    return pThis->EnablePlugin(lParam1 != 0);
  case TVTest::EVENT_PROGRAMGUIDE_INITIALIZE:
    // ԑg\̏
    pThis->m_hwndProgramGuide = reinterpret_cast<HWND>(lParam1);
    pThis->init_flag = true;
    return TRUE;
  case TVTest::EVENT_PROGRAMGUIDE_PROGRAM_DRAWBACKGROUND:
    {
      const TVTest::ProgramGuideProgramDrawBackgroundInfo *pInfo =
	reinterpret_cast<const TVTest::ProgramGuideProgramDrawBackgroundInfo*>(lParam2);

      //ԑg\`lP̕擾
      pThis->ItemWidth = pInfo->ItemRect.right - pInfo->ItemRect.left + ITEM_MARGIN*2;

      TEXTMETRIC tm;//tHg̍^Co[̕Zoɗv
      GetTextMetrics(pInfo->hdc, &tm);
      pThis->tmHeight = tm.tmHeight;

      //XN[͈͎擾
      GetScrollRange(pThis->m_hwndProgramGuide, SB_HORZ, &pThis->ScrollMin, &pThis->ScrollMax);

      // EVENT_PROGRAMGUIDE_INITIALIZEoA
      // EPGԑg\EChE쐬ʂĨCxgŌo
      // EPGԑg\EChE쐬ɂP񂾂s
      if(pThis->init_flag)
	{
	  pThis->init_flag = false;
	  if(pThis->m_pApp->IsPluginEnabled())
	    pThis->TTScroll(pThis->m_hwndProgramGuide);//XN[s
	}
    }
    break;

  case TVTest::EVENT_SETTINGSCHANGE:
    //MessageBox(pThis->m_hwndProgramGuide, L"EVENT_SETTINGSCHANGE", L"TTScroll", MB_OK);
    break;

  case TVTest::EVENT_PROGRAMGUIDE_FINALIZE:
    // ԑg\̏I
    pThis->m_hwndProgramGuide = NULL;
    return TRUE;

  default:
    {
      //WCHAR str[32];
      //wsprintf(str, L"%d", Event);
      //MessageBox(pThis->m_hwndProgramGuide, (LPWSTR)str, L"TTScroll", MB_OK);
    }
    break;
  }
  return 0;
}

//[ProgramGuideService]
//ExcludeServiceCount=1
//ExcludeService0=4,16625,101
void CTTScroll::LoadProfile(WCHAR *IniPath)
{
  ExcludeServiceCount = GetPrivateProfileInt(L"ProgramGuideService",
					     L"ExcludeServiceCount", 0, IniPath);
  BYTE *p;
  if(ExcludeServiceCount == 0 ||
     !(p = (BYTE *)malloc((sizeof(TVTest::ChannelInfo *)+sizeof(TVTest::ChannelInfo))*ExcludeServiceCount)))
    return;

  ExcludeServiceList = (TVTest::ChannelInfo **)p;
  p += sizeof(TVTest::ChannelInfo *)*ExcludeServiceCount;

  WCHAR DefaultKey[] = L"0,0,0";
  for(int i = 0; i < ExcludeServiceCount; i++)
    {
      ExcludeServiceList[i] = (TVTest::ChannelInfo *)(p + sizeof(TVTest::ChannelInfo) * i);

      WCHAR KeyNameBuf[128];
      wsprintf(KeyNameBuf, L"ExcludeService%d", i);
      
      WCHAR KeyBuf[128];
      GetPrivateProfileString(L"ProgramGuideService",
			      KeyNameBuf,
			      DefaultKey,
			      KeyBuf,
			      ARRAY_SIZE(KeyBuf),
			      IniPath);      

      WCHAR *n, *t, *s, *next; 
      if((n = wcstok_s(KeyBuf, L",", &next)) == NULL ||
	 (t = wcstok_s(NULL, L",", &next)) == NULL ||
	 (s = wcstok_s(NULL, L",", &next)) == NULL)
	n = L"0", t = L"0", s = L"0";

      ExcludeServiceList[i]->NetworkID = _wtoi(n);
      ExcludeServiceList[i]->TransportStreamID = _wtoi(t);
      ExcludeServiceList[i]->ServiceID = _wtoi(s);

#if 0
      WCHAR str[32];
      wsprintf(str, L"n:%d t:%d s:%d",
	       ExcludeServiceList[i]->NetworkID,
	       ExcludeServiceList[i]->TransportStreamID,
	       ExcludeServiceList[i]->ServiceID);
      MessageBox(NULL, (LPWSTR)str, L"TTScroll", MB_OK);
#endif
    }
}

CTTScroll::CTTScroll()
  : ExcludeServiceCount(0)
  , ExcludeServiceList(NULL)
{
  
}

CTTScroll::~CTTScroll()
{
  
}

bool CTTScroll::Initialize()
{
  // ŏs
  // Ȃ̂ł΃I[o[ChȂĂǂ

  //"TVTest.ini"ݒǂ
  WCHAR szIniPath[MAX_PATH];
  if (m_pApp->GetSetting(L"IniFilePath", szIniPath, MAX_PATH) > 0)
    LoadProfile(szIniPath);

  // ԑg\̃Cxg̒ʒmLɂ(m_hwndProgramGuide擾邽)
  m_pApp->EnableProgramGuideEvent(TVTest::PROGRAMGUIDE_EVENT_GENERAL);

  // CxgR[obN֐o^
  m_pApp->SetEventCallback(EventCallback, this);

  return true;	// false ԂƃvOC̃[hsɂȂ
}

bool CTTScroll::Finalize()
{
  // ŃN[Abvs
  // Ȃ̂ł΃I[o[ChȂĂǂ
  if(ExcludeServiceList)
    {
      free(ExcludeServiceList);
      ExcludeServiceList = NULL;
    }
  return true;
}

// vOC̗LԂω
bool CTTScroll::EnablePlugin(bool fEnable, bool fExit)
{
  if (!fExit) {
    // ԑg\̃Cxg̒ʒm̗L/ݒ肷
    m_pApp->EnableProgramGuideEvent(TVTest::PROGRAMGUIDE_EVENT_GENERAL |
    				    (fEnable ? TVTest::PROGRAMGUIDE_EVENT_PROGRAM : 0));
    RedrawProgramGuide();
  }
  return true;
}

// CreatePluginClass ֐ŁAvOCNX̃CX^X𐶐ĕԂ
TVTest::CTVTestPlugin *CreatePluginClass()
{
  return new CTTScroll;
}
