#ifndef TTSCROLL_H
#define TTSCROLL_H

//Refer to "ProgramGuide.cpp"
#define ITEM_MARGIN 4
#define TIMEBAR_SHADOW_WIDTH	6

#define ARRAY_SIZE(a) _countof(a)

// vOCNXBCTVTestPlugin h
class CTTScroll : public TVTest::CTVTestPlugin
{
public:
  CTTScroll();
  ~CTTScroll();
  bool GetPluginInfo(TVTest::PluginInfo *pInfo) {
    // vOC̏Ԃ
    pInfo->Type           = TVTest::PLUGIN_TYPE_NORMAL;
    pInfo->Flags          = 0;
    pInfo->pszPluginName  = L"TTScroll";
    pInfo->pszCopyright   = L"Copyright(c) 2012 sanmaiwashi (admin@wazoku.net)";
    pInfo->pszDescription = L"ԑg\XN[ (ver.0.2.4)";
    return true;	// false ԂƃvOC̃[hsɂȂ
  }
  bool Initialize();
  bool Finalize();
private:
  static LRESULT CALLBACK EventCallback(UINT Event, LPARAM lParam1, LPARAM lParam2, void *pClientData);
  bool EnablePlugin(bool fEnable, bool fExit = false);
  HWND m_hwndProgramGuide;
  void RedrawProgramGuide() const { if (m_hwndProgramGuide) ::InvalidateRect(m_hwndProgramGuide, NULL, TRUE); }
  void TTScroll(HWND hWnd);
  bool init_flag;
  int GetItemIndex(int *pNumItems=NULL);
  int GetItemIndexBySpace(TVTest::ChannelInfo *pInfo, int Space, int *pNumItems=NULL);
  int ItemWidth, GuideWidth, sClientWidth, tmHeight, ScrollMin, ScrollMax;
  int Get_x(int ItemIndex);
  void LoadProfile(WCHAR *IniPath);
  int ExcludeServiceCount;
  TVTest::ChannelInfo **ExcludeServiceList;
  bool IsExcludeService(WORD NetworkID, WORD TransportStreamID, WORD ServiceID);
};

#endif	// TTSCROLL_H
